diff --git a/gcc/analyzer/constraint-manager.cc b/gcc/analyzer/constraint-manager.cc
index 786bd6ccf85..2f7a6537493 100644
--- a/gcc/analyzer/constraint-manager.cc
+++ b/gcc/analyzer/constraint-manager.cc
@@ -2010,7 +2426,8 @@ test_constant_comparisons ()
     /* If "a <= 4" && "a > 3", then "a == 4",
        assuming a is of integral type.  */
     {
-      region_model model;
+      region_model_manager mgr;
+      region_model model (&mgr);
       ADD_SAT_CONSTRAINT (model, a, LE_EXPR, int_4);
       ADD_SAT_CONSTRAINT (model, a, GT_EXPR, int_3);
       ASSERT_CONDITION_TRUE (model, a, EQ_EXPR, int_4);
@@ -2019,7 +2436,8 @@ test_constant_comparisons ()
     /* If "a > 3" && "a <= 4", then "a == 4",
        assuming a is of integral type.  */
     {
-      region_model model;
+      region_model_manager mgr;
+      region_model model (&mgr);
       ADD_SAT_CONSTRAINT (model, a, GT_EXPR, int_3);
       ADD_SAT_CONSTRAINT (model, a, LE_EXPR, int_4);
       ASSERT_CONDITION_TRUE (model, a, EQ_EXPR, int_4);
@@ -2027,7 +2445,8 @@ test_constant_comparisons ()
     /* If "a > 3" && "a < 5", then "a == 4",
        assuming a is of integral type.  */
     {
-      region_model model;
+      region_model_manager mgr;
+      region_model model (&mgr);
       ADD_SAT_CONSTRAINT (model, a, GT_EXPR, int_3);
       ADD_SAT_CONSTRAINT (model, a, LT_EXPR, int_5);
       ASSERT_CONDITION_TRUE (model, a, EQ_EXPR, int_4);
@@ -2035,14 +2454,16 @@ test_constant_comparisons ()
     /* If "a >= 4" && "a < 5", then "a == 4",
        assuming a is of integral type.  */
     {
-      region_model model;
+      region_model_manager mgr;
+      region_model model (&mgr);
       ADD_SAT_CONSTRAINT (model, a, GE_EXPR, int_4);
       ADD_SAT_CONSTRAINT (model, a, LT_EXPR, int_5);
       ASSERT_CONDITION_TRUE (model, a, EQ_EXPR, int_4);
     }
     /* If "a >= 4" && "a <= 4", then "a == 4".  */
     {
-      region_model model;
+      region_model_manager mgr;
+      region_model model (&mgr);
       ADD_SAT_CONSTRAINT (model, a, GE_EXPR, int_4);
       ADD_SAT_CONSTRAINT (model, a, LE_EXPR, int_4);
       ASSERT_CONDITION_TRUE (model, a, EQ_EXPR, int_4);
@@ -2056,7 +2477,8 @@ test_constant_comparisons ()
     tree float_3 = build_real_from_int_cst (double_type_node, int_3);
     tree float_4 = build_real_from_int_cst (double_type_node, int_4);
 
-    region_model model;
+    region_model_manager mgr;
+    region_model model (&mgr);
     ADD_SAT_CONSTRAINT (model, f, GT_EXPR, float_3);
     ADD_SAT_CONSTRAINT (model, f, LE_EXPR, float_4);
     ASSERT_CONDITION_UNKNOWN (model, f, EQ_EXPR, float_4);
@@ -2079,7 +2501,8 @@ test_constraint_impl ()
 
   /* x == y.  */
   {
-    region_model model;
+    region_model_manager mgr;
+    region_model model (&mgr);
 
     ADD_SAT_CONSTRAINT (model, x, EQ_EXPR, y);
 
@@ -2091,7 +2514,8 @@ test_constraint_impl ()
 
   /* y <= z; x == y.  */
   {
-    region_model model;
+    region_model_manager mgr;
+    region_model model (&mgr);
     ASSERT_CONDITION_UNKNOWN (model, x, EQ_EXPR, y);
     ASSERT_CONDITION_UNKNOWN (model, x, GE_EXPR, z);
 
@@ -2112,7 +2536,8 @@ test_constraint_impl ()
 
   /* y <= z; y == x.  */
   {
-    region_model model;
+    region_model_manager mgr;
+    region_model model (&mgr);
     ASSERT_CONDITION_UNKNOWN (model, x, EQ_EXPR, y);
     ASSERT_CONDITION_UNKNOWN (model, x, GE_EXPR, z);
 
@@ -2133,20 +2558,16 @@ test_constraint_impl ()
 
   /* x == 0, then x != 42.  */
   {
-    region_model model;
+    region_model_manager mgr;
+    region_model model (&mgr);
 
     ADD_SAT_CONSTRAINT (model, x, EQ_EXPR, int_0);
     ADD_SAT_CONSTRAINT (model, x, NE_EXPR, int_42);
 
     /* Assert various things about the insides of model.  */
     constraint_manager *cm = model.get_constraints ();
-    ASSERT_EQ (cm->m_constraints.length (), 1);
-    ASSERT_EQ (cm->m_equiv_classes.length (), 2);
-    ASSERT_EQ (cm->m_constraints[0].m_lhs,
-	       cm->get_or_add_equiv_class (model.get_rvalue (int_0, NULL)));
-    ASSERT_EQ (cm->m_constraints[0].m_rhs,
-	       cm->get_or_add_equiv_class (model.get_rvalue (int_42, NULL)));
-    ASSERT_EQ (cm->m_constraints[0].m_op, CONSTRAINT_LT);
+    ASSERT_EQ (cm->m_constraints.length (), 0);
+    ASSERT_EQ (cm->m_equiv_classes.length (), 1);
   }
 
   // TODO: selftest for merging ecs "in the middle"
@@ -2165,8 +2586,9 @@ test_equality ()
   tree y = build_global_decl ("y", integer_type_node);
 
   {
-    region_model model0;
-    region_model model1;
+    region_model_manager mgr;
+    region_model model0 (&mgr);
+    region_model model1 (&mgr);
 
     constraint_manager *cm0 = model0.get_constraints ();
     constraint_manager *cm1 = model1.get_constraints ();
@@ -2184,7 +2606,7 @@ test_equality ()
     ASSERT_NE (model0.hash (), model1.hash ());
     ASSERT_NE (model0, model1);
 
-    region_model model2;
+    region_model model2 (&mgr);
     constraint_manager *cm2 = model2.get_constraints ();
     /* Make the same change to cm2.  */
     ADD_SAT_CONSTRAINT (model2, x, EQ_EXPR, y);
@@ -2201,9 +2623,11 @@ test_equality ()
 static void
 test_many_constants ()
 {
+  program_point point (program_point::origin ());
   tree a = build_global_decl ("a", integer_type_node);
 
-  region_model model;
+  region_model_manager mgr;
+  region_model model (&mgr);
   auto_vec<tree> constants;
   for (int i = 0; i < 20; i++)
     {
@@ -2214,10 +2638,10 @@ test_many_constants ()
       /* Merge, and check the result.  */
       region_model other (model);
 
-      region_model merged;
-      ASSERT_TRUE (model.can_merge_with_p (other, &merged));
-      model.canonicalize (NULL);
-      merged.canonicalize (NULL);
+      region_model merged (&mgr);
+      ASSERT_TRUE (model.can_merge_with_p (other, point, &merged));
+      model.canonicalize ();
+      merged.canonicalize ();
       ASSERT_EQ (model, merged);
 
       for (int j = 0; j <= i; j++)
@@ -2239,8 +2663,8 @@ run_constraint_manager_tests (bool transitivity)
     {
       /* These selftests assume transitivity.  */
       test_transitivity ();
-      test_constant_comparisons ();
     }
+  test_constant_comparisons ();
   test_constraint_impl ();
   test_equality ();
   test_many_constants ();
diff --git a/gcc/analyzer/constraint-manager.h b/gcc/analyzer/constraint-manager.h
index 0f4506cc40d..3c31a891f70 100644
--- a/gcc/analyzer/constraint-manager.h
+++ b/gcc/analyzer/constraint-manager.h
@@ -25,17 +25,47 @@ namespace ana {
 
 class constraint_manager;
 
-/* Abstract base class for specifying how state should be purged.  */
+/* One of the end-points of a range.  */
 
-class purge_criteria
+struct bound
 {
-public:
-  virtual ~purge_criteria () {}
-  virtual bool should_purge_p (svalue_id sid) const = 0;
+  bound () : m_constant (NULL_TREE), m_closed (false) {}
+  bound (tree constant, bool closed)
+  : m_constant (constant), m_closed (closed) {}
+
+  void ensure_closed (bool is_upper);
+
+  const char * get_relation_as_str () const;
+
+  tree m_constant;
+  bool m_closed;
+};
+
+/* A range of values, used for determining if a value has been
+   constrained to just one possible constant value.  */
+
+struct range
+{
+  range () : m_lower_bound (), m_upper_bound () {}
+  range (const bound &lower, const bound &upper)
+  : m_lower_bound (lower), m_upper_bound (upper) {}
+
+  void dump_to_pp (pretty_printer *pp) const;
+  void dump () const;
+
+  tree constrained_to_single_element ();
+
+  tristate eval_condition (enum tree_code op,
+			   tree rhs_const) const;
+  bool below_lower_bound (tree rhs_const) const;
+  bool above_upper_bound (tree rhs_const) const;
+
+  bound m_lower_bound;
+  bound m_upper_bound;
 };
 
 /* An equivalence class within a constraint manager: a set of
-   svalue_ids that are known to all be equal to each other,
+   svalues that are known to all be equal to each other,
    together with an optional tree constant that they are equal to.  */
 
 class equiv_class
@@ -47,14 +77,12 @@ public:
   hashval_t hash () const;
   bool operator== (const equiv_class &other);
 
-  void add (svalue_id sid, const constraint_manager &cm);
-  bool del (svalue_id sid);
+  void add (const svalue *sval);
+  bool del (const svalue *sval);
 
   tree get_any_constant () const { return m_constant; }
 
-  svalue_id get_representative () const;
-
-  void remap_svalue_ids (const svalue_id_map &map);
+  const svalue *get_representative () const;
 
   void canonicalize ();
 
@@ -64,10 +92,10 @@ public:
      different zeroes, for different types); these are just for the last
      constant added.  */
   tree m_constant;
-  svalue_id m_cst_sid;
+  const svalue *m_cst_sval;
 
   // TODO: should this be a set rather than a vec?
-  auto_vec<svalue_id> m_vars;
+  auto_vec<const svalue *> m_vars;
 };
 
 /* The various kinds of constraint.  */
@@ -141,6 +169,9 @@ class constraint
     return m_op != CONSTRAINT_NE;
   }
 
+  bool implied_by (const constraint &other,
+		   const constraint_manager &cm) const;
+
   equiv_class_id m_lhs;
   enum constraint_op m_op;
   equiv_class_id m_rhs;
@@ -152,7 +183,9 @@ class fact_visitor
 {
  public:
   virtual ~fact_visitor () {}
-  virtual void on_fact (svalue_id lhs, enum tree_code, svalue_id rhs) = 0;
+  virtual void on_fact (const svalue *lhs,
+			enum tree_code,
+			const svalue *rhs) = 0;
 };
 
 /* A collection of equivalence classes and constraints on them.
@@ -164,15 +197,10 @@ class fact_visitor
 class constraint_manager
 {
 public:
-  constraint_manager () {}
+  constraint_manager (region_model_manager *mgr) : m_mgr (mgr) {}
   constraint_manager (const constraint_manager &other);
   virtual ~constraint_manager () {}
 
-  virtual constraint_manager *clone (region_model *) const = 0;
-  virtual tree maybe_get_constant (svalue_id sid) const = 0;
-  virtual svalue_id get_sid_for_constant (tree cst) const = 0;
-  virtual int get_num_svalues () const = 0;
-
   constraint_manager& operator= (const constraint_manager &other);
 
   hashval_t hash () const;
@@ -183,7 +211,7 @@ public:
   }
 
   void print (pretty_printer *pp) const;
-  void dump_to_pp (pretty_printer *pp) const;
+  void dump_to_pp (pretty_printer *pp, bool multiline) const;
   void dump (FILE *fp) const;
   void dump () const;
 
@@ -196,32 +224,47 @@ public:
     return *m_equiv_classes[idx];
   }
 
-  equiv_class &get_equiv_class (svalue_id sid)
+  equiv_class &get_equiv_class (const svalue *sval)
   {
-    equiv_class_id ec_id = get_or_add_equiv_class (sid);
+    equiv_class_id ec_id = get_or_add_equiv_class (sval);
     return ec_id.get_obj (*this);
   }
 
-  bool add_constraint (svalue_id lhs, enum tree_code op, svalue_id rhs);
+  bool add_constraint (const svalue *lhs,
+		       enum tree_code op,
+		       const svalue *rhs);
 
   bool add_constraint (equiv_class_id lhs_ec_id,
 		       enum tree_code op,
 		       equiv_class_id rhs_ec_id);
 
-  bool get_equiv_class_by_sid (svalue_id sid, equiv_class_id *out) const;
-  equiv_class_id get_or_add_equiv_class (svalue_id sid);
+  void add_unknown_constraint (equiv_class_id lhs_ec_id,
+			       enum tree_code op,
+			       equiv_class_id rhs_ec_id);
+
+  bool get_equiv_class_by_svalue (const svalue *sval,
+				    equiv_class_id *out) const;
+  equiv_class_id get_or_add_equiv_class (const svalue *sval);
   tristate eval_condition (equiv_class_id lhs,
 			   enum tree_code op,
-			   equiv_class_id rhs);
-  tristate eval_condition (svalue_id lhs,
+			   equiv_class_id rhs) const;
+  tristate eval_condition (equiv_class_id lhs_ec,
+			   enum tree_code op,
+			   tree rhs_const) const;
+  tristate eval_condition (const svalue *lhs,
 			   enum tree_code op,
-			   svalue_id rhs);
+			   const svalue *rhs) const;
+  range get_ec_bounds (equiv_class_id ec_id) const;
 
-  void purge (const purge_criteria &p, purge_stats *stats);
+  /* PurgeCriteria should have:
+     bool should_purge_p (const svalue *sval) const.  */
+  template <typename PurgeCriteria>
+  void purge (const PurgeCriteria &p, purge_stats *stats);
 
-  void remap_svalue_ids (const svalue_id_map &map);
+  void on_liveness_change (const svalue_set &live_svalues,
+			   const region_model *model);
 
-  void canonicalize (unsigned num_svalue_ids);
+  void canonicalize ();
 
   static void merge (const constraint_manager &cm_a,
 		     const constraint_manager &cm_b,
@@ -236,13 +279,11 @@ public:
   auto_vec<constraint> m_constraints;
 
  private:
-  static void clean_merger_input (const constraint_manager &cm_in,
-				  const one_way_svalue_id_map &map_sid_to_m,
-				  constraint_manager *out);
-
   void add_constraint_internal (equiv_class_id lhs_id,
 				enum constraint_op c_op,
 				equiv_class_id rhs_id);
+
+  region_model_manager *m_mgr;
 };
 
 } // namespace ana
